Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class CompositeView

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.CompositeView

All Implemented Interfaces:
  SwingConstants

Direct Known Subclasses:
  BoxView

public abstract class CompositeView
extends View

A view that is composed of other views (has children). As a container of children, the composite view needs to provide:

services to manage the collection of children
  The following methods can be used to manage the collection.
  - removeAll
  - insert
  - append
  - replace
  - getViewCount
  - getView
  - loadChildren
layout of the children
  This class does not implement a layout policy as it is abstract. A subclass will determine how the children are laid out by implementing the setSize method to position the children when the size has been changed.
paint the children
  This class does not attempt to paint the children. Subclasses will want to use the layout information and call paint on the children that are visible (intersect the clipping region) with the Shape argument set to the location of the child view.
propagation of DocumentEvent information to the appropriate children.
propagation of model/view translation to the proper child.

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Fields inherited from interface javax.swing.SwingConstants
`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NORTH, NORTH_EAST, NORTH_WEST, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

Constructor Summary
`CompositeView(Element elem)` Constructs a CompositeView for the given element.

Method Summary
`protected abstract void` | `childAllocation(int index, Rectangle a)` Returns the allocation for a given child.
`protected boolean` | `flipEastAndWestAtEnds(int position, Position.Bias bias)` Subclasses may wish to subclass this and conditionally return true based on the position.
`protected short` | `getBottomInset()` Gets the bottom inset.
`Shape` | `getChildAllocation(int index, Shape a)` Fetches the allocation for the given child view.
`protected Rectangle` | `getInsideAllocation(Shape a)` Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e.
`protected short` | `getLeftInset()` Gets the left inset.
`protected int` | `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)` Returns the next visual position for the cursor, in either the east or west direction.
`protected int` | `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)` Returns the next visual position for the cursor, in either the east or west direction.
`int` | `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)` Provides a way to determine the next visually represented model location that one might place a caret.
`protected short` | `getRightInset()` Gets the right inset.
`protected short` | `getTopInset()` Gets the top inset.
`View` | `getView(int n)` Gets the n-th view in this container.
`protected abstract View` | `getViewAtPoint(int x, int y, Rectangle alloc)` Fetches the child view at the given point.
`protected View` | `getViewAtPosition(int pos, Rectangle a)` Fetches the child view that represents the given position in the model.
`int` | `getViewCount()` Returns the number of child views of this view.
`int` | `getViewIndex(int pos, Position.Bias b)` Returns the child view index representing the given position in the model.
`protected int` | `getViewIndexAtPosition(int pos)` Fetches the child view index representing the given position in the model.
`protected abstract boolean` | `isAfter(int x, int y, Rectangle alloc)` Tests whether a point lies after the rectangle range.
`protected abstract boolean` | `isBefore(int x, int y, Rectangle alloc)` Tests whether a point lies before the rectangle range.
`protected void` | `loadChildren(ViewFactory f)` Loads all of the children to initialize the view.
`Shape` | `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`Shape` | `modelToView(int pos, Shape a, Position.Bias b)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`void` | `replace(int offset, int length, View[] views)` Replace child views.
`protected void` | `setInsets(short top, short left, short bottom, short right)` Sets the insets for the view.
`protected void` | `setParagraphInsets(AttributeSet attr)` Sets the insets from the paragraph attributes specified in the given attributes.
`void` | `setParent(View parent)` Sets the parent of the view.
`int` | `viewToModel(float x, float y, Shape a, Position.Bias[] bias)` Provides a mapping from the view coordinate space to the logical coordinate space of the model.

Methods inherited from class javax.swing.text.View
`append, breakView, changedUpdate, createFragment, forwardUpdate, forwardUpdateToView, getAlignment, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getMaximumSpan, getMinimumSpan, getParent, getPreferredSpan, getResizeWeight, getStartOffset, getViewFactory, insert, insertUpdate, isVisible, modelToView, paint, preferenceChanged, remove, removeAll, removeUpdate, setSize, updateChildren, updateLayout, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CompositeView

    public CompositeView(Element elem)

  Constructs a CompositeView for the given element.
  Parameters:
    `elem` - the element this view is responsible for

Method Detail

### loadChildren

    protected void loadChildren(ViewFactory f)

  Loads all of the children to initialize the view. This is called by the setParent method. Subclasses can reimplement this to initialize their child views in a different manner. The default implementation creates a child view for each child element.
  Parameters:
    `f` - the view factory
  See Also:
    `setParent(javax.swing.text.View)`

### setParent

    public void setParent(View parent)

  Sets the parent of the view. This is reimplemented to provide the superclass behavior as well as calling the `loadChildren` method if this view does not already have children. The children should not be loaded in the constructor because the act of setting the parent may cause them to try to search up the hierarchy (to get the hosting Container for example). If this view has children (the view is being moved from one place in the view hierarchy to another), the `loadChildren` method will not be called.
  Overrides:
    `setParent` in class `View`
  Parameters:
    `parent` - the parent of the view, null if none

### getViewCount

    public int getViewCount()

  Returns the number of child views of this view.
  Overrides:
    `getViewCount` in class `View`
  Returns:
    the number of views >= 0
  See Also:
    `getView(int)`

### getView

    public View getView(int n)

  Gets the n-th view in this container.
  Overrides:
    `getView` in class `View`
  Parameters:
    `n` - the number of the view to get, >= 0 && < getViewCount()
  Returns:
    the view

### replace

    public void replace(int offset,
                        int length,
                        View[] views)

  Replace child views. If there are no views to remove this acts as an insert. If there are no views to add this acts as a remove. Views being removed will have the parent set to null, and the internal reference to them removed so that they can be garbage collected.
  Overrides:
    `replace` in class `View`
  Parameters:
    `index` - the starting index into the child views to insert the new views. This should be a value >= 0 and <= getViewCount.
    `length` - the number of existing child views to remove. This should be a value >= 0 and <= (getViewCount() - offset).
    `views` - the child views to add. This value can be null to indicate no children are being added (useful to remove).

### getChildAllocation

    public Shape getChildAllocation(int index,
                                    Shape a)

  Fetches the allocation for the given child view. This enables finding out where various views are located.
  Overrides:
    `getChildAllocation` in class `View`
  Parameters:
    `index` - the index of the child, >= 0 && < getViewCount()
    `a` - the allocation to this view.
  Returns:
    the allocation to the child

### modelToView

    public Shape modelToView(int pos,
                             Shape a,
                             Position.Bias b)
                      throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  Overrides:
    `modelToView` in class `View`
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position
  Throws:
    `BadLocationException` - if the given position does not represent a valid location in the associated document
  See Also:
    `View.modelToView(int, java.awt.Shape, javax.swing.text.Position.Bias)`

### modelToView

    public Shape modelToView(int p0,
                             Position.Bias b0,
                             int p1,
                             Position.Bias b1,
                             Shape a)
                      throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  Overrides:
    `modelToView` in class `View`
  Parameters:
    `p0` - the position to convert >= 0
    `b0` - the bias toward the previous character or the next character represented by p0, in case the position is a boundary of two views.
    `p1` - the position to convert >= 0
    `b1` - the bias toward the previous character or the next character represented by p1, in case the position is a boundary of two views.
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position is returned
  Throws:
    `BadLocationException` - if the given position does not represent a valid location in the associated document
    `IllegalArgumentException` - for an invalid bias argument
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### viewToModel

    public int viewToModel(float x,
                           float y,
                           Shape a,
                           Position.Bias[] bias)

  Provides a mapping from the view coordinate space to the logical coordinate space of the model.
  Overrides:
    `viewToModel` in class `View`
  Parameters:
    `x` - x coordinate of the view location to convert >= 0
    `y` - y coordinate of the view location to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the location within the model that best represents the given point in the view >= 0
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### getNextVisualPositionFrom

    public int getNextVisualPositionFrom(int pos,
                                         Position.Bias b,
                                         Shape a,
                                         int direction,
                                         Position.Bias[] biasRet)
                                  throws BadLocationException

  Provides a way to determine the next visually represented model location that one might place a caret. Some views may not be visible, they might not be in the same order found in the model, or they just might not allow access to some of the locations in the model.
  Overrides:
    `getNextVisualPositionFrom` in class `View`
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
    `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard. This may be SwingConstants.WEST, SwingConstants.EAST, SwingConstants.NORTH, or SwingConstants.SOUTH.
  Returns:
    the location within the model that best represents the next location visual position.
  Throws:
    `BadLocationException` -
    `IllegalArgumentException` - for an invalid direction

### getViewIndex

    public int getViewIndex(int pos,
                            Position.Bias b)

  Returns the child view index representing the given position in the model. This is implemented to call the getViewIndexByPosition method for backward compatibility.
  Overrides:
    `getViewIndex` in class `View`
  Parameters:
    `pos` - the position >= 0

### isBefore

    protected abstract boolean isBefore(int x,
                                        int y,
                                        Rectangle alloc)

  Tests whether a point lies before the rectangle range.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the rectangle
  Returns:
    true if the point is before the specified range

### isAfter

    protected abstract boolean isAfter(int x,
                                       int y,
                                       Rectangle alloc)

  Tests whether a point lies after the rectangle range.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the rectangle
  Returns:
    true if the point is after the specified range

### getViewAtPoint

    protected abstract View getViewAtPoint(int x,
                                           int y,
                                           Rectangle alloc)

  Fetches the child view at the given point.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the parent's allocation on entry, which should be changed to the child's allocation on exit
  Returns:
    the child view

### childAllocation

    protected abstract void childAllocation(int index,
                                            Rectangle a)

  Returns the allocation for a given child.
  Parameters:
    `index` - the index of the child, >= 0 && < getViewCount()
    `a` - the allocation to the interior of the box on entry, and the allocation of the child view at the index on exit.

### getViewAtPosition

    protected View getViewAtPosition(int pos,
                                     Rectangle a)

  Fetches the child view that represents the given position in the model. This is implemented to fetch the view in the case where there is a child view for each child element.
  Parameters:
    `pos` - the position >= 0
    `a` - the allocation to the interior of the box on entry, and the allocation of the view containing the position on exit

### getViewIndexAtPosition

    protected int getViewIndexAtPosition(int pos)

  Fetches the child view index representing the given position in the model. This is implemented to fetch the view in the case where there is a child view for each child element.
  Parameters:
    `pos` - the position >= 0

### getInsideAllocation

    protected Rectangle getInsideAllocation(Shape a)

  Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed. It is expected that the returned value would be further mutated to represent an allocation to a child view. This is implemented to reuse an instance variable so it avoids creating excessive Rectangles. Typically the result of calling this method would be fed to the childAllocation method.
  Parameters:
    `a` - The allocation given to the view.

### setParagraphInsets

    protected void setParagraphInsets(AttributeSet attr)

  Sets the insets from the paragraph attributes specified in the given attributes.
  Parameters:
    `attr` - the attributes

### setInsets

    protected void setInsets(short top,
                             short left,
                             short bottom,
                             short right)

  Sets the insets for the view.
  Parameters:
    `top` - the top inset >= 0
    `left` - the left inset >= 0
    `bottom` - the bottom inset >= 0
    `right` - the right inset >= 0

### getLeftInset

    protected short getLeftInset()

  Gets the left inset.
  Returns:
    the inset >= 0

### getRightInset

    protected short getRightInset()

  Gets the right inset.
  Returns:
    the inset >= 0

### getTopInset

    protected short getTopInset()

  Gets the top inset.
  Returns:
    the inset >= 0

### getBottomInset

    protected short getBottomInset()

  Gets the bottom inset.
  Returns:
    the inset >= 0

### getNextNorthSouthVisualPositionFrom

    protected int getNextNorthSouthVisualPositionFrom(int pos,
                                                      Position.Bias b,
                                                      Shape a,
                                                      int direction,
                                                      Position.Bias[] biasRet)
                                               throws BadLocationException

  Returns the next visual position for the cursor, in either the east or west direction.
  Returns:
    next position west of the passed in position.

### getNextEastWestVisualPositionFrom

    protected int getNextEastWestVisualPositionFrom(int pos,
                                                    Position.Bias b,
                                                    Shape a,
                                                    int direction,
                                                    Position.Bias[] biasRet)
                                             throws BadLocationException

  Returns the next visual position for the cursor, in either the east or west direction.
  Returns:
    next position west of the passed in position.

### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position,
                                            Position.Bias bias)

  Subclasses may wish to subclass this and conditionally return true based on the position. A return value of true indicates that when a View returns -1 from getNextVisualPositionFrom the next view for east should be the current index offset by -1, and for west it means offset by 1. The normal direction (for left to right text) is to offset east by 1 and west by -1.
  Returns:
    false

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.